<?php
//BOAS Unified Diff to BOASL Converter
//string convert_diff(array diff_source)
function convert_diff($diff)
{
	$boasl = array("version(\"0.3.0\")\n");
	$space = array(); //lines with " " as first char
	$remove = array(); //lines with "-" as first char
	$add = array(); //lines with "+" as first char
	$file = ""; //file to edit
	$type = 0; //resets to 0 after a round of " -+"
	$lastaction = " ";
	$addnewline = true;
	$removenewline = true;
	if(strpos($diff[count($diff)], "\n") !== false)
	{
		$diff[] = "";
	}
	for($i = 1;$i <= count($diff);)
	{
		if($i == count($diff) || $diff[$i] == "")
		{
			$diff[$i] = "  Fake";
			$type = 2;
		}
		if(strpos($diff[$i], "Index: ") === 0)
		{
			$file = substr(str_replace(array("\n", "Index: "), "", $diff[$i]), 0);
			$boasl[] = "open(\"".substr($file, 0, -1)."\")\n";
			$i += 4;
		}
		elseif(strpos($diff[$i], "--- ") === 0)
		{
			$file = preg_replace("/--- (.*?)	\((.*?)\)/i", "$1", $diff[$i]);
			$boasl[] = "open(\"".substr($file, 0, -2)."\")\n";
			$i += 2;
		}
		elseif(strpos($diff[$i], "\\ No newline at end of file") === 0)
		{
			if($lastaction == "+")
			{
				$addnewline = false;
			}
			elseif($lastaction == "-")
			{
				$removenewline = false;
			}
			$i++;
		}
		elseif(strpos($diff[$i], "@@") === 0 || strpos($diff[$i], "\\") === 0)
		{
			$i++;
			$space = array();
			$add = array();
			$remove = array();
			$type = 0;
		}
		elseif(strpos($diff[$i], " ") === 0)
		{
			if($type !== 0)
			{
				if($addnewline)
				{
					$add[] = "\n";
				}
				if($removenewline)
				{
					$remove[] = "\n";
				}
				$addnewline = true;
				$removenewline = true;
				$boasl[] = "Find:\n";
				for($j = 0;$j < count($space);$j++)
				{
					$boasl[] = $space[$j];
				}
				for($j = 0;$j < count($remove);$j++)
				{
					$boasl[] = $remove[$j];
				}
				if($type === 1 && $lastaction = "+")
				{
					$boasl[] = "Add:\n";
				}
				else
				{
					$boasl[] = "Replace:\n";
					for($j = 0;$j < count($space);$j++)
					{
						$boasl[] = $space[$j];
					}
				}
				for($j = 0;$j < count($add);$j++)
				{
					$boasl[] = $add[$j];
				}
				$space = array();
				$add = array();
				$remove = array();
				$type = 0;
			}
			$space[] = substr($diff[$i], 1);
			$i++;
			$lastaction = " ";
		}
		elseif(strpos($diff[$i], "-") === 0)
		{
			$remove[] = substr($diff[$i], 1);
			if($lastaction != "-")
			{
				$type++;
			}
			$i++;
			$lastaction = "-";
		}
		elseif(strpos($diff[$i], "+") === 0)
		{
			$add[] = substr($diff[$i], 1);
			if($lastaction != "+")
			{
				$type++;
			}
			$i++;
			$lastaction = "+";
		}
	}
	return implode("", $boasl);
}
?>