<?php
if(!function_exists("display_news")) //this step should happen only once per page
{
	$_bitowl["temp"] = explode("&", $_SERVER["QUERY_STRING"]); //get all variables from url
	$_bitowl["temp2"] = count($_bitowl["temp"]);
	for($i = 0;$i < $_bitowl["temp2"];$i++) //strip certain ones
	{
		if(strpos($_bitowl["temp"][$i], "newspage=") !== false)
		{
			unset($_bitowl["temp"][$i]);
		}
		elseif(strpos($_bitowl["temp"][$i], "category=") !== false)
		{
			unset($_bitowl["temp"][$i]);
		}
		elseif(strpos($_bitowl["temp"][$i], "newsid=") !== false)
		{
			unset($_bitowl["temp"][$i]);
		}
		elseif(strpos($_bitowl["temp"][$i], "amp;") !== false) //support for some servers?
		{
			unset($_bitowl["temp"][$i]);
		}
	}
	$_bitowl["temp"] = implode("&amp;", $_bitowl["temp"])."&amp;";
	if($_bitowl["temp"] == "&amp;")
	{
		$_bitowl["temp"] = "";
	}
	$_SERVER["QUERY_STRING"] = $_bitowl["temp"];
	require "$path/db/news.php";
	require "$path/db/comments.php";
	function check_valid_category($display, $test) //test to see if we want to display a post by checking the category
	{
		if(!is_array($display)) //only one category specified
		{
			if($display == -1)
			{
				return true;
			}
			elseif(strpos(implode(",", $test), $display) !== false)
			{
				return true;
			}
		}
		else //more then one category
		{
			for($i = 0;$i < count($display);$i++)
			{
				if(strpos(implode(",", $test), $display[$i]) !== false)
				{
					return true;
				}
			}
		}
		return false;
	}
	function category_id2name($cid) //converts category id to name
	{
		global $categories;
		for($i = 0;$i < count($categories);$i++)
		{
			if($categories[$i]["id"] == $cid)
			{
				return $categories[$i]["name"];
			}
		}
	}
	function get_category_news($category) //this processes the news into by category news used in display_news()
	{
		global $news, $categories, $_bitowl;
		for($i = 0;$i < count($news);$i++)
		{
			if(!is_array($category))
			{
				if(strpos(implode(",", $news[$i]["categories"]), $category) !== false)
				{
					$cat_news[] = $news[$i];
				}
			}
			else
			{
				for($j = 0;$j < count($category);$j++)
				{
					if(strpos(implode(",", $news[$i]["categories"]), $category[$j]) !== false)
					{
						$cat_news[] = $news[$i];
						break;
					}
				}
			}
		}
		$cat_news = isset($cat_news) ? $cat_news : array();
		return $cat_news;
	}
	function display_news($category = -1, $page = 1) //this decides what post to display and sets the news var to category
	{
		global $news, $categories, $_bitowl;
		if(is_array($category) || $category != -1)
		{
			$news = get_category_news($category);
		}
		$start = (count($news)-1)-($_bitowl["news"]["itemperpage"]*($page-1));
		$end = $start - $_bitowl["news"]["itemperpage"] + 1;
		if($end < 0)
		{
			$end = 0;
		}
		if($_bitowl["news"]["itemperpage"] <= 0)
		{
			$start = count($news)-1;
			$end = 0;
		}
		for($i = $start;$i >= $end;$i--)
		{
			if(check_valid_category($category, $news[$i]["categories"]))
			{
				display_news_item($i);
			}
		}
	}
	function display_news_item($id) //this displays the post
	{
		global $news, $categories, $_bitowl;
		if(!isset($news[$id]))
		{
			return false;
		}
		$title = stripslashes($news[$id]["title"]);
		$message = stripslashes($news[$id]["message"]);
		$date = date($_bitowl["news"]["date"], $news[$id]["date"]);
		$author = $news[$id]["author"];
		$cat_avatar = $news[$id]["categories"][0];
		for($i = 0;$i < count($categories);$i++)
		{
			if($categories[$i]["id"] == $cat_avatar)
			{
				$cat_avatar = $categories[$i]["avatar"];
				if($cat_avatar === false)
				{
					$cat_avatar = "&nbsp;";
				}
				break;
			}
		}
		if($cat_avatar === $news[$id]["categories"][0])
		{
			$cat_avatar = "&nbsp;";
		}
		for($i = 0;$i < count($news[$id]["categories"]);$i++)
		{
			$news[$id]["categories"][$i] = "<a href=\"?".$_SERVER["QUERY_STRING"]."category=".$news[$id]["categories"][$i]."\">".category_id2name($news[$id]["categories"][$i])."</a>";
		}
		$news_categories = implode(", ", $news[$id]["categories"]);
		$commentcount = display_comments($news[$id]["id"], true, false, true); //comment count
		$data = array("author" => $author, "categories" => $news_categories, "category_avatar" => $cat_avatar, "date" => $date, "title" => $title, "message" => $message, "comments" => $commentcount, "item_link" => "?".$_SERVER["QUERY_STRING"]."newsid=".$id, "email" => "", "previous_page" => "", "next_page" => "", "page_list" => "", "truncated_list" => "");
		echo parse_template("news-item.html", $data);
		return true;
	}
	function display_page_nav($current_page) // < 1 2 3 > etc part
	{
		global $news, $categories, $_bitowl;
		$pages = ceil(count($news)/$_bitowl["news"]["itemperpage"]);
		$prev_page = $current_page - 1;
		$next_page = $current_page + 1;
		if($prev_page != 0)
		{
			$prev_page = "?".$_SERVER["QUERY_STRING"]."newspage=".$prev_page;
		}
		else
		{
			$prev_page = "&nbsp;";
		}
		$linked = "";
		$trunc = "";
		if($current_page >= 5)
		{
			$trunc = "...";
		}
		for($i = 1;$i <= $pages;$i++)
		{
			if($i != $current_page)
			{
				if($i >= $current_page - 3 && $i <= $current_page + 3)
				{
					$trunc = $trunc."<a href=\"?".$_SERVER["QUERY_STRING"]."newspage=$i\">$i</a>";
				}
				elseif($current_page - 3 < 1 && $i <= $current_page + 3 + abs($current_page - 4))
				{
					$trunc = $trunc."<a href=\"?".$_SERVER["QUERY_STRING"]."newspage=$i\">$i</a>";
				}
				$linked = $linked."<a href=\"?".$_SERVER["QUERY_STRING"]."newspage=$i\">$i</a>";
			}
			else
			{
				$trunc = $trunc.$i;
				$linked = $linked.$i;
			}
			if($i < $pages)
			{
				if($i >= $current_page - 3 && $i <= $current_page + 3)
				{
					$trunc = $trunc." ";
				}
				elseif($current_page - 3 < 1 && $i <= $current_page + 3 + abs($current_page - 4))
				{
					$trunc = $trunc." ";
				}
				$linked = $linked." ";
			}
		}
		if($current_page + 3 < $pages)
		{
			$trunc = $trunc."...";
		}
		if($next_page != $pages+1 && $pages != 0)
		{
			$next_page = "?".$_SERVER["QUERY_STRING"]."newspage=".$next_page;
		}
		else
		{
			$next_page = "&nbsp;";
		}
		$data = array("author" => "", "categories" => "", "category_avatar" => "", "date" => "", "title" => "", "message" => "", "comments" => "", "item_link" => "", "email" => "", "previous_page" => $prev_page, "next_page" => $next_page, "page_list" => $linked, "truncated_list" => $trunc);
		echo parse_template("news-pages.html", $data);
	}
	function display_comments($newsid, $count = false, $form = true, $absoluteid = false) //list comments or alternativly count them
	{
		global $_bitowl, $path, $fullpath, $news, $comment, $comment_result;
		if(!$count)
		{
			include "$path/captcha.php";
			$captcha = new CAPTCHA();
			if(isset($_bitowl["master"]["captcha"]) && $_bitowl["master"]["captcha"] == true)
			{
				$_SESSION["solution"] = $captcha->str;
			}
			else
			{
				$_SESSION["solution"] = "";
			}
		}
		if(!$absoluteid) //covert dynamic id to static id
		{
			$newsid = $news[$newsid]["id"];
		}
		$commentcount = 0;
		for($i = 0;$i < count($comment);$i++)
		{
			if($comment[$i]["post"] == $newsid)
			{
				if(!$count)
				{
					$date = date($_bitowl["news"]["date"], $comment[$i]["date"]);
					$data = array("author" => $comment[$i]["author"], "categories" => "", "category_avatar" => "", "date" => $date, "title" => "", "message" => $comment[$i]["comment"], "comments" => 0, "item_link" => "?".$_SERVER["QUERY_STRING"]."newsid=".$newsid, "email" => $comment[$i]["email"], "previous_page" => "", "next_page" => "", "page_list" => "", "truncated_list" => "");
					echo parse_template("news-comment-item.html", $data);
				}
				else
				{
					$commentcount++;
				}
			}
		}
		if($form)
		{
			$data["captcha"] = "$fullpath/viewcaptcha.php?sid=".session_id();
			if($comment_result == false)
			{
				$data["captcha_result"] = "Incorrect Code";
			}
			else
			{
				$data["captcha_result"] = "";
			}
			echo parse_template("news-comment-form.html", $data);
			session_write_close();
		}
		if($count)
		{
			return $commentcount;
		}
		else
		{
			return true;
		}
	}
	function post_comment()
	{
		global $_bitowl, $path, $news, $comment;
		$id = 0;
		for($i = 0;$i < count($comment);$i++)
		{
			if($comment[$i]["id"] >= $id)
			{
				$id = $comment[$i]["id"] + 1;
			}
		}
		$author = $_POST["name"];
		$email = $_POST["email"];
		$message = htmlentities(str_replace("\n", "<br />", $_POST["comment"])); //HTML in comments is pontentually bad.
		//check session
		if(!isset($_SESSION["solution"]) || $_SESSION["solution"] != $_POST["solution"])
		{
			return false;
		}
		$str = "\$comment[] = array(\"id\" => $id, \"post\" => ".$news[$_GET["newsid"]]["id"].", \"author\" => \"$author\", \"email\" => \"$email\", \"date\" => \"".time()."\", \"comment\" => \"$message\");\n";
		$file = file("$path/db/comments.php");
		$pos = count($file) - 1;
		$file[$pos] = $str;
		$file[] = "?>";
		$write = fopen("$path/db/comments.php", "w");
		fwrite($write, implode("", $file));
		fclose($write);
		return true;
	}
}
else //reset the db vars
{
	unset($news, $categories);
	require "$path/db/news.php";
}
if(!is_array($_GET["category"]))
{
	$_GET["category"] = isset($_GET["category"]) ? ''.$_GET["category"] : -1; //''. makes this work
}
else
{
	for($i = 0;$i < count($_GET["category"]);$i++)
	{
		$_GET["category"][$i] = ''.$_GET["category"][$i]; //''. makes this work again
	}
}
$_GET["newspage"] = isset($_GET["newspage"]) ? $_GET["newspage"] : 1;
if(!isset($_GET["newsid"]) || (isset($_GET["newsid"]) && !isset($news[$_GET["newsid"]])))
{
	display_news($_GET["category"], $_GET["newspage"]);
}
else
{
	if(isset($_POST["name"]))
	{
		$comment_result = post_comment();
		unset($comment);
		include "$path/db/comments.php";
	}
	if(display_news_item($_GET["newsid"]))
	{
		display_comments($_GET["newsid"]);
	}
}
if($_bitowl["news"]["pages"])
{
	display_page_nav($_GET["newspage"]);
}
?>